<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_ErrMessages extends Controller_Handler {
		
        public function before() {
            $this->model = new Model_errMessages;
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }
        
        public function action_getRequests() {
			$data = $this->model->getRequests($this->user['AccID']);

            $i =0;
            $res = array();
            foreach ($data as $row) 
            {
                $res[$i] = $row;
                ++$i;
            }       
            $res['num'] = --$i;     

			$this->response->body(json_encode($res)); 
        }

        public function action_createRequest() {
         	$title = $_POST['title'];
         	$text = $_POST['text'];
            $result = $this->model->newRequest($this->user['ID'], $title, $text);

            $to = "it.lab.mmcs@gmail.com";
            $subject =  "Request ".$result[0]['Num'].": rating system report"; 
            
            $message =  "Faculty: ".$this->user['FacultyName']."\n";
            $message .= "Type: ".$this->user['Type']."\n";
            if ($this->user['Type'] === "teacher") {
                $message .= "Department: ".$this->user['DepName']."\n";
            } else if ($this->user['Type'] === "student") {
                $message .= "Degree: ".$this->user['Degree'];
                $message .= "  Grade: ".$this->user['GradeNum'];
                $message .= "  Group: ".$this->user['GroupNum']."\n";
            }
            $message .= "Sender: ".$this->user['Last'].' '.$this->user['First'].' '.$this->user['Second']."\n\n";
            $message .= "Title: ".$title."\n";
            $message .= "Message: ".$text;

            $headers =  "From: RatingSystem@no-reply.mmcs.sfedu.ru\n";
            $headers .= "Reply-To: ".$this->user['EMail'];

            $data['success'] = true;
            mail($to, $subject, $message, $headers);

            $data['success'] = ($result[0]['Num'] > 0);
            
            $this->response->body(json_encode($data));
	    }
}
